#pragma once

#include "constants/const_feat.hpp"
#include "constants/const_spell.hpp"

#include "../../rules/Class.hpp"
#include "../../rules/Effect.hpp"
#include "../../rules/combat.hpp"
#include "../../rules/items.hpp"

namespace nwn1 {

constexpr nw::Ability ability_strength = nw::Ability::make(0);
constexpr nw::Ability ability_dexterity = nw::Ability::make(1);
constexpr nw::Ability ability_constitution = nw::Ability::make(2);
constexpr nw::Ability ability_intelligence = nw::Ability::make(3);
constexpr nw::Ability ability_wisdom = nw::Ability::make(4);
constexpr nw::Ability ability_charisma = nw::Ability::make(5);

constexpr nw::Appearance appearance_type_invalid = nw::Appearance::invalid();
constexpr nw::Appearance appearance_type_allip = nw::Appearance::make(186);
constexpr nw::Appearance appearance_type_aranea = nw::Appearance::make(157);
constexpr nw::Appearance appearance_type_arch_target = nw::Appearance::make(200);
constexpr nw::Appearance appearance_type_aribeth = nw::Appearance::make(190);
constexpr nw::Appearance appearance_type_asabi_chieftain = nw::Appearance::make(353);
constexpr nw::Appearance appearance_type_asabi_shaman = nw::Appearance::make(354);
constexpr nw::Appearance appearance_type_asabi_warrior = nw::Appearance::make(355);
constexpr nw::Appearance appearance_type_badger = nw::Appearance::make(8);
constexpr nw::Appearance appearance_type_badger_dire = nw::Appearance::make(9);
constexpr nw::Appearance appearance_type_balor = nw::Appearance::make(38);
constexpr nw::Appearance appearance_type_bartender = nw::Appearance::make(234);
constexpr nw::Appearance appearance_type_basilisk = nw::Appearance::make(369);
constexpr nw::Appearance appearance_type_bat = nw::Appearance::make(10);
constexpr nw::Appearance appearance_type_bat_horror = nw::Appearance::make(11);
constexpr nw::Appearance appearance_type_bear_black = nw::Appearance::make(12);
constexpr nw::Appearance appearance_type_bear_brown = nw::Appearance::make(13);
constexpr nw::Appearance appearance_type_bear_dire = nw::Appearance::make(15);
constexpr nw::Appearance appearance_type_bear_kodiak = nw::Appearance::make(204);
constexpr nw::Appearance appearance_type_bear_polar = nw::Appearance::make(14);
constexpr nw::Appearance appearance_type_beetle_fire = nw::Appearance::make(18);
constexpr nw::Appearance appearance_type_beetle_slicer = nw::Appearance::make(17);
constexpr nw::Appearance appearance_type_beetle_stag = nw::Appearance::make(19);
constexpr nw::Appearance appearance_type_beetle_stink = nw::Appearance::make(20);
constexpr nw::Appearance appearance_type_begger = nw::Appearance::make(220);
constexpr nw::Appearance appearance_type_blood_sailer = nw::Appearance::make(221);
constexpr nw::Appearance appearance_type_boar = nw::Appearance::make(21);
constexpr nw::Appearance appearance_type_boar_dire = nw::Appearance::make(22);
constexpr nw::Appearance appearance_type_bodak = nw::Appearance::make(23);
constexpr nw::Appearance appearance_type_bugbear_a = nw::Appearance::make(29);
constexpr nw::Appearance appearance_type_bugbear_b = nw::Appearance::make(30);
constexpr nw::Appearance appearance_type_bugbear_chieftain_a = nw::Appearance::make(25);
constexpr nw::Appearance appearance_type_bugbear_chieftain_b = nw::Appearance::make(26);
constexpr nw::Appearance appearance_type_bugbear_shaman_a = nw::Appearance::make(27);
constexpr nw::Appearance appearance_type_bugbear_shaman_b = nw::Appearance::make(28);
constexpr nw::Appearance appearance_type_bulette = nw::Appearance::make(481);
constexpr nw::Appearance appearance_type_cat_cat_dire = nw::Appearance::make(95);
constexpr nw::Appearance appearance_type_cat_cougar = nw::Appearance::make(203);
constexpr nw::Appearance appearance_type_cat_crag_cat = nw::Appearance::make(94);
constexpr nw::Appearance appearance_type_cat_jaguar = nw::Appearance::make(98);
constexpr nw::Appearance appearance_type_cat_krenshar = nw::Appearance::make(96);
constexpr nw::Appearance appearance_type_cat_leopard = nw::Appearance::make(93);
constexpr nw::Appearance appearance_type_cat_lion = nw::Appearance::make(97);
constexpr nw::Appearance appearance_type_cat_mpanther = nw::Appearance::make(306);
constexpr nw::Appearance appearance_type_cat_panther = nw::Appearance::make(202);
constexpr nw::Appearance appearance_type_chicken = nw::Appearance::make(31);
constexpr nw::Appearance appearance_type_cockatrice = nw::Appearance::make(368);
constexpr nw::Appearance appearance_type_combat_dummy = nw::Appearance::make(201);
constexpr nw::Appearance appearance_type_convict = nw::Appearance::make(238);
constexpr nw::Appearance appearance_type_cow = nw::Appearance::make(34);
constexpr nw::Appearance appearance_type_cult_member = nw::Appearance::make(212);
constexpr nw::Appearance appearance_type_deer = nw::Appearance::make(35);
constexpr nw::Appearance appearance_type_deer_stag = nw::Appearance::make(37);
constexpr nw::Appearance appearance_type_devil = nw::Appearance::make(392);
constexpr nw::Appearance appearance_type_dog = nw::Appearance::make(176);
constexpr nw::Appearance appearance_type_dog_blinkdog = nw::Appearance::make(174);
constexpr nw::Appearance appearance_type_dog_dire_wolf = nw::Appearance::make(175);
constexpr nw::Appearance appearance_type_dog_fenhound = nw::Appearance::make(177);
constexpr nw::Appearance appearance_type_dog_hell_hound = nw::Appearance::make(179);
constexpr nw::Appearance appearance_type_dog_shadow_mastif = nw::Appearance::make(180);
constexpr nw::Appearance appearance_type_dog_winter_wolf = nw::Appearance::make(184);
constexpr nw::Appearance appearance_type_dog_wolf = nw::Appearance::make(181);
constexpr nw::Appearance appearance_type_dog_worg = nw::Appearance::make(185);
constexpr nw::Appearance appearance_type_doom_knight = nw::Appearance::make(40);
constexpr nw::Appearance appearance_type_dragon_black = nw::Appearance::make(41);
constexpr nw::Appearance appearance_type_dragon_blue = nw::Appearance::make(47);
constexpr nw::Appearance appearance_type_dragon_brass = nw::Appearance::make(42);
constexpr nw::Appearance appearance_type_dragon_bronze = nw::Appearance::make(45);
constexpr nw::Appearance appearance_type_dragon_copper = nw::Appearance::make(43);
constexpr nw::Appearance appearance_type_dragon_gold = nw::Appearance::make(46);
constexpr nw::Appearance appearance_type_dragon_green = nw::Appearance::make(48);
constexpr nw::Appearance appearance_type_dragon_red = nw::Appearance::make(49);
constexpr nw::Appearance appearance_type_dragon_silver = nw::Appearance::make(44);
constexpr nw::Appearance appearance_type_dragon_white = nw::Appearance::make(50);
constexpr nw::Appearance appearance_type_drow_cleric = nw::Appearance::make(215);
constexpr nw::Appearance appearance_type_drow_fighter = nw::Appearance::make(216);
constexpr nw::Appearance appearance_type_druegar_cleric = nw::Appearance::make(218);
constexpr nw::Appearance appearance_type_druegar_fighter = nw::Appearance::make(217);
constexpr nw::Appearance appearance_type_dryad = nw::Appearance::make(51);
constexpr nw::Appearance appearance_type_dwarf = nw::Appearance::make(0);
constexpr nw::Appearance appearance_type_dwarf_npc_female = nw::Appearance::make(248);
constexpr nw::Appearance appearance_type_dwarf_npc_male = nw::Appearance::make(249);
constexpr nw::Appearance appearance_type_elemental_air = nw::Appearance::make(52);
constexpr nw::Appearance appearance_type_elemental_air_elder = nw::Appearance::make(53);
constexpr nw::Appearance appearance_type_elemental_earth = nw::Appearance::make(56);
constexpr nw::Appearance appearance_type_elemental_earth_elder = nw::Appearance::make(57);
constexpr nw::Appearance appearance_type_elemental_fire = nw::Appearance::make(60);
constexpr nw::Appearance appearance_type_elemental_fire_elder = nw::Appearance::make(61);
constexpr nw::Appearance appearance_type_elemental_water = nw::Appearance::make(69);
constexpr nw::Appearance appearance_type_elemental_water_elder = nw::Appearance::make(68);
constexpr nw::Appearance appearance_type_elf = nw::Appearance::make(1);
constexpr nw::Appearance appearance_type_elf_npc_female = nw::Appearance::make(245);
constexpr nw::Appearance appearance_type_elf_npc_male_01 = nw::Appearance::make(246);
constexpr nw::Appearance appearance_type_elf_npc_male_02 = nw::Appearance::make(247);
constexpr nw::Appearance appearance_type_ettercap = nw::Appearance::make(166);
constexpr nw::Appearance appearance_type_ettin = nw::Appearance::make(72);
constexpr nw::Appearance appearance_type_faerie_dragon = nw::Appearance::make(374);
constexpr nw::Appearance appearance_type_fairy = nw::Appearance::make(55);
constexpr nw::Appearance appearance_type_falcon = nw::Appearance::make(144);
constexpr nw::Appearance appearance_type_female_01 = nw::Appearance::make(222);
constexpr nw::Appearance appearance_type_female_02 = nw::Appearance::make(223);
constexpr nw::Appearance appearance_type_female_03 = nw::Appearance::make(224);
constexpr nw::Appearance appearance_type_female_04 = nw::Appearance::make(225);
constexpr nw::Appearance appearance_type_formian_myrmarch = nw::Appearance::make(362);
constexpr nw::Appearance appearance_type_formian_queen = nw::Appearance::make(363);
constexpr nw::Appearance appearance_type_formian_warrior = nw::Appearance::make(361);
constexpr nw::Appearance appearance_type_formian_worker = nw::Appearance::make(360);
constexpr nw::Appearance appearance_type_gargoyle = nw::Appearance::make(73);
constexpr nw::Appearance appearance_type_ghast = nw::Appearance::make(74);
constexpr nw::Appearance appearance_type_ghoul = nw::Appearance::make(76);
constexpr nw::Appearance appearance_type_ghoul_lord = nw::Appearance::make(77);
constexpr nw::Appearance appearance_type_giant_fire = nw::Appearance::make(80);
constexpr nw::Appearance appearance_type_giant_fire_female = nw::Appearance::make(351);
constexpr nw::Appearance appearance_type_giant_frost = nw::Appearance::make(81);
constexpr nw::Appearance appearance_type_giant_frost_female = nw::Appearance::make(350);
constexpr nw::Appearance appearance_type_giant_hill = nw::Appearance::make(78);
constexpr nw::Appearance appearance_type_giant_mountain = nw::Appearance::make(79);
constexpr nw::Appearance appearance_type_gnoll_warrior = nw::Appearance::make(388);
constexpr nw::Appearance appearance_type_gnoll_wiz = nw::Appearance::make(389);
constexpr nw::Appearance appearance_type_gnome = nw::Appearance::make(2);
constexpr nw::Appearance appearance_type_gnome_npc_female = nw::Appearance::make(243);
constexpr nw::Appearance appearance_type_gnome_npc_male = nw::Appearance::make(244);
constexpr nw::Appearance appearance_type_goblin_a = nw::Appearance::make(86);
constexpr nw::Appearance appearance_type_goblin_b = nw::Appearance::make(87);
constexpr nw::Appearance appearance_type_goblin_chief_a = nw::Appearance::make(82);
constexpr nw::Appearance appearance_type_goblin_chief_b = nw::Appearance::make(83);
constexpr nw::Appearance appearance_type_goblin_shaman_a = nw::Appearance::make(84);
constexpr nw::Appearance appearance_type_goblin_shaman_b = nw::Appearance::make(85);
constexpr nw::Appearance appearance_type_golem_bone = nw::Appearance::make(24);
constexpr nw::Appearance appearance_type_golem_clay = nw::Appearance::make(91);
constexpr nw::Appearance appearance_type_golem_flesh = nw::Appearance::make(88);
constexpr nw::Appearance appearance_type_golem_iron = nw::Appearance::make(89);
constexpr nw::Appearance appearance_type_golem_stone = nw::Appearance::make(92);
constexpr nw::Appearance appearance_type_gorgon = nw::Appearance::make(367);
constexpr nw::Appearance appearance_type_gray_ooze = nw::Appearance::make(393);
constexpr nw::Appearance appearance_type_grey_render = nw::Appearance::make(205);
constexpr nw::Appearance appearance_type_gynosphinx = nw::Appearance::make(365);
constexpr nw::Appearance appearance_type_halfling = nw::Appearance::make(3);
constexpr nw::Appearance appearance_type_halfling_npc_female = nw::Appearance::make(250);
constexpr nw::Appearance appearance_type_halfling_npc_male = nw::Appearance::make(251);
constexpr nw::Appearance appearance_type_half_elf = nw::Appearance::make(4);
constexpr nw::Appearance appearance_type_half_orc = nw::Appearance::make(5);
constexpr nw::Appearance appearance_type_half_orc_npc_female = nw::Appearance::make(252);
constexpr nw::Appearance appearance_type_half_orc_npc_male_01 = nw::Appearance::make(253);
constexpr nw::Appearance appearance_type_half_orc_npc_male_02 = nw::Appearance::make(254);
constexpr nw::Appearance appearance_type_helmed_horror = nw::Appearance::make(100);
constexpr nw::Appearance appearance_type_heurodis_lich = nw::Appearance::make(370);
constexpr nw::Appearance appearance_type_hobgoblin_warrior = nw::Appearance::make(390);
constexpr nw::Appearance appearance_type_hobgoblin_wizard = nw::Appearance::make(391);
constexpr nw::Appearance appearance_type_hook_horror = nw::Appearance::make(102);
constexpr nw::Appearance appearance_type_house_guard = nw::Appearance::make(219);
constexpr nw::Appearance appearance_type_human = nw::Appearance::make(6);
constexpr nw::Appearance appearance_type_human_npc_female_01 = nw::Appearance::make(255);
constexpr nw::Appearance appearance_type_human_npc_female_02 = nw::Appearance::make(256);
constexpr nw::Appearance appearance_type_human_npc_female_03 = nw::Appearance::make(257);
constexpr nw::Appearance appearance_type_human_npc_female_04 = nw::Appearance::make(258);
constexpr nw::Appearance appearance_type_human_npc_female_05 = nw::Appearance::make(259);
constexpr nw::Appearance appearance_type_human_npc_female_06 = nw::Appearance::make(260);
constexpr nw::Appearance appearance_type_human_npc_female_07 = nw::Appearance::make(261);
constexpr nw::Appearance appearance_type_human_npc_female_08 = nw::Appearance::make(262);
constexpr nw::Appearance appearance_type_human_npc_female_09 = nw::Appearance::make(263);
constexpr nw::Appearance appearance_type_human_npc_female_10 = nw::Appearance::make(264);
constexpr nw::Appearance appearance_type_human_npc_female_11 = nw::Appearance::make(265);
constexpr nw::Appearance appearance_type_human_npc_female_12 = nw::Appearance::make(266);
constexpr nw::Appearance appearance_type_human_npc_male_01 = nw::Appearance::make(267);
constexpr nw::Appearance appearance_type_human_npc_male_02 = nw::Appearance::make(268);
constexpr nw::Appearance appearance_type_human_npc_male_03 = nw::Appearance::make(269);
constexpr nw::Appearance appearance_type_human_npc_male_04 = nw::Appearance::make(270);
constexpr nw::Appearance appearance_type_human_npc_male_05 = nw::Appearance::make(271);
constexpr nw::Appearance appearance_type_human_npc_male_06 = nw::Appearance::make(272);
constexpr nw::Appearance appearance_type_human_npc_male_07 = nw::Appearance::make(273);
constexpr nw::Appearance appearance_type_human_npc_male_08 = nw::Appearance::make(274);
constexpr nw::Appearance appearance_type_human_npc_male_09 = nw::Appearance::make(275);
constexpr nw::Appearance appearance_type_human_npc_male_10 = nw::Appearance::make(276);
constexpr nw::Appearance appearance_type_human_npc_male_11 = nw::Appearance::make(277);
constexpr nw::Appearance appearance_type_human_npc_male_12 = nw::Appearance::make(278);
constexpr nw::Appearance appearance_type_human_npc_male_13 = nw::Appearance::make(279);
constexpr nw::Appearance appearance_type_human_npc_male_14 = nw::Appearance::make(280);
constexpr nw::Appearance appearance_type_human_npc_male_15 = nw::Appearance::make(281);
constexpr nw::Appearance appearance_type_human_npc_male_16 = nw::Appearance::make(282);
constexpr nw::Appearance appearance_type_human_npc_male_17 = nw::Appearance::make(283);
constexpr nw::Appearance appearance_type_human_npc_male_18 = nw::Appearance::make(284);
constexpr nw::Appearance appearance_type_imp = nw::Appearance::make(105);
constexpr nw::Appearance appearance_type_inn_keeper = nw::Appearance::make(233);
constexpr nw::Appearance appearance_type_intellect_devourer = nw::Appearance::make(117);
constexpr nw::Appearance appearance_type_invisible_human_male = nw::Appearance::make(298);
constexpr nw::Appearance appearance_type_invisible_stalker = nw::Appearance::make(64);
constexpr nw::Appearance appearance_type_kid_female = nw::Appearance::make(242);
constexpr nw::Appearance appearance_type_kid_male = nw::Appearance::make(241);
constexpr nw::Appearance appearance_type_kobold_a = nw::Appearance::make(302);
constexpr nw::Appearance appearance_type_kobold_b = nw::Appearance::make(305);
constexpr nw::Appearance appearance_type_kobold_chief_a = nw::Appearance::make(300);
constexpr nw::Appearance appearance_type_kobold_chief_b = nw::Appearance::make(303);
constexpr nw::Appearance appearance_type_kobold_shaman_a = nw::Appearance::make(301);
constexpr nw::Appearance appearance_type_kobold_shaman_b = nw::Appearance::make(304);
constexpr nw::Appearance appearance_type_lantern_archon = nw::Appearance::make(103);
constexpr nw::Appearance appearance_type_lich = nw::Appearance::make(39);
constexpr nw::Appearance appearance_type_lizardfolk_a = nw::Appearance::make(134);
constexpr nw::Appearance appearance_type_lizardfolk_b = nw::Appearance::make(135);
constexpr nw::Appearance appearance_type_lizardfolk_shaman_a = nw::Appearance::make(132);
constexpr nw::Appearance appearance_type_lizardfolk_shaman_b = nw::Appearance::make(133);
constexpr nw::Appearance appearance_type_lizardfolk_warrior_a = nw::Appearance::make(130);
constexpr nw::Appearance appearance_type_lizardfolk_warrior_b = nw::Appearance::make(131);
constexpr nw::Appearance appearance_type_luskan_guard = nw::Appearance::make(211);
constexpr nw::Appearance appearance_type_male_01 = nw::Appearance::make(226);
constexpr nw::Appearance appearance_type_male_02 = nw::Appearance::make(227);
constexpr nw::Appearance appearance_type_male_03 = nw::Appearance::make(228);
constexpr nw::Appearance appearance_type_male_04 = nw::Appearance::make(229);
constexpr nw::Appearance appearance_type_male_05 = nw::Appearance::make(230);
constexpr nw::Appearance appearance_type_manticore = nw::Appearance::make(366);
constexpr nw::Appearance appearance_type_medusa = nw::Appearance::make(352);
constexpr nw::Appearance appearance_type_mephit_air = nw::Appearance::make(106);
constexpr nw::Appearance appearance_type_mephit_dust = nw::Appearance::make(107);
constexpr nw::Appearance appearance_type_mephit_earth = nw::Appearance::make(108);
constexpr nw::Appearance appearance_type_mephit_fire = nw::Appearance::make(109);
constexpr nw::Appearance appearance_type_mephit_ice = nw::Appearance::make(110);
constexpr nw::Appearance appearance_type_mephit_magma = nw::Appearance::make(114);
constexpr nw::Appearance appearance_type_mephit_ooze = nw::Appearance::make(112);
constexpr nw::Appearance appearance_type_mephit_salt = nw::Appearance::make(111);
constexpr nw::Appearance appearance_type_mephit_steam = nw::Appearance::make(113);
constexpr nw::Appearance appearance_type_mephit_water = nw::Appearance::make(115);
constexpr nw::Appearance appearance_type_minogon = nw::Appearance::make(119);
constexpr nw::Appearance appearance_type_minotaur = nw::Appearance::make(120);
constexpr nw::Appearance appearance_type_minotaur_chieftain = nw::Appearance::make(121);
constexpr nw::Appearance appearance_type_minotaur_shaman = nw::Appearance::make(122);
constexpr nw::Appearance appearance_type_mohrg = nw::Appearance::make(123);
constexpr nw::Appearance appearance_type_mummy_common = nw::Appearance::make(58);
constexpr nw::Appearance appearance_type_mummy_fighter_2 = nw::Appearance::make(59);
constexpr nw::Appearance appearance_type_mummy_greater = nw::Appearance::make(124);
constexpr nw::Appearance appearance_type_mummy_warrior = nw::Appearance::make(125);
constexpr nw::Appearance appearance_type_nwn_aarin = nw::Appearance::make(188);
constexpr nw::Appearance appearance_type_nwn_aribeth_evil = nw::Appearance::make(189);
constexpr nw::Appearance appearance_type_nwn_haedraline = nw::Appearance::make(191);
constexpr nw::Appearance appearance_type_nwn_maugrim = nw::Appearance::make(193);
constexpr nw::Appearance appearance_type_nwn_morag = nw::Appearance::make(192);
constexpr nw::Appearance appearance_type_nwn_nasher = nw::Appearance::make(296);
constexpr nw::Appearance appearance_type_nwn_sedos = nw::Appearance::make(297);
constexpr nw::Appearance appearance_type_nw_militia_member = nw::Appearance::make(210);
constexpr nw::Appearance appearance_type_nymph = nw::Appearance::make(126);
constexpr nw::Appearance appearance_type_ochre_jelly_large = nw::Appearance::make(394);
constexpr nw::Appearance appearance_type_ochre_jelly_medium = nw::Appearance::make(396);
constexpr nw::Appearance appearance_type_ochre_jelly_small = nw::Appearance::make(398);
constexpr nw::Appearance appearance_type_ogre = nw::Appearance::make(127);
constexpr nw::Appearance appearance_type_ogreb = nw::Appearance::make(207);
constexpr nw::Appearance appearance_type_ogre_chieftain = nw::Appearance::make(128);
constexpr nw::Appearance appearance_type_ogre_chieftainb = nw::Appearance::make(208);
constexpr nw::Appearance appearance_type_ogre_mage = nw::Appearance::make(129);
constexpr nw::Appearance appearance_type_ogre_mageb = nw::Appearance::make(209);
constexpr nw::Appearance appearance_type_old_man = nw::Appearance::make(239);
constexpr nw::Appearance appearance_type_old_woman = nw::Appearance::make(240);
constexpr nw::Appearance appearance_type_orc_a = nw::Appearance::make(140);
constexpr nw::Appearance appearance_type_orc_b = nw::Appearance::make(141);
constexpr nw::Appearance appearance_type_orc_chieftain_a = nw::Appearance::make(136);
constexpr nw::Appearance appearance_type_orc_chieftain_b = nw::Appearance::make(137);
constexpr nw::Appearance appearance_type_orc_shaman_a = nw::Appearance::make(138);
constexpr nw::Appearance appearance_type_orc_shaman_b = nw::Appearance::make(139);
constexpr nw::Appearance appearance_type_ox = nw::Appearance::make(142);
constexpr nw::Appearance appearance_type_parrot = nw::Appearance::make(7);
constexpr nw::Appearance appearance_type_penguin = nw::Appearance::make(206);
constexpr nw::Appearance appearance_type_plague_victim = nw::Appearance::make(231);
constexpr nw::Appearance appearance_type_prostitute_01 = nw::Appearance::make(236);
constexpr nw::Appearance appearance_type_prostitute_02 = nw::Appearance::make(237);
constexpr nw::Appearance appearance_type_pseudodragon = nw::Appearance::make(375);
constexpr nw::Appearance appearance_type_quasit = nw::Appearance::make(104);
constexpr nw::Appearance appearance_type_rakshasa_bear_male = nw::Appearance::make(294);
constexpr nw::Appearance appearance_type_rakshasa_tiger_female = nw::Appearance::make(290);
constexpr nw::Appearance appearance_type_rakshasa_tiger_male = nw::Appearance::make(293);
constexpr nw::Appearance appearance_type_rakshasa_wolf_male = nw::Appearance::make(295);
constexpr nw::Appearance appearance_type_rat = nw::Appearance::make(386);
constexpr nw::Appearance appearance_type_rat_dire = nw::Appearance::make(387);
constexpr nw::Appearance appearance_type_raven = nw::Appearance::make(145);
constexpr nw::Appearance appearance_type_sahuagin = nw::Appearance::make(65);
constexpr nw::Appearance appearance_type_sahuagin_leader = nw::Appearance::make(66);
constexpr nw::Appearance appearance_type_sahuagin_cleric = nw::Appearance::make(67);
constexpr nw::Appearance appearance_type_seagull_flying = nw::Appearance::make(291);
constexpr nw::Appearance appearance_type_seagull_walking = nw::Appearance::make(292);
constexpr nw::Appearance appearance_type_shadow = nw::Appearance::make(146);
constexpr nw::Appearance appearance_type_shadow_fiend = nw::Appearance::make(147);
constexpr nw::Appearance appearance_type_shark_mako = nw::Appearance::make(447);
constexpr nw::Appearance appearance_type_shark_hammerhead = nw::Appearance::make(448);
constexpr nw::Appearance appearance_type_shark_goblin = nw::Appearance::make(449);
constexpr nw::Appearance appearance_type_shield_guardian = nw::Appearance::make(90);
constexpr nw::Appearance appearance_type_shop_keeper = nw::Appearance::make(232);
constexpr nw::Appearance appearance_type_skeletal_devourer = nw::Appearance::make(36);
constexpr nw::Appearance appearance_type_skeleton_chieftain = nw::Appearance::make(182);
constexpr nw::Appearance appearance_type_skeleton_common = nw::Appearance::make(63);
constexpr nw::Appearance appearance_type_skeleton_mage = nw::Appearance::make(148);
constexpr nw::Appearance appearance_type_skeleton_priest = nw::Appearance::make(62);
constexpr nw::Appearance appearance_type_skeleton_warrior = nw::Appearance::make(150);
constexpr nw::Appearance appearance_type_skeleton_warrior_1 = nw::Appearance::make(70);
constexpr nw::Appearance appearance_type_skeleton_warrior_2 = nw::Appearance::make(71);
constexpr nw::Appearance appearance_type_slaad_blue = nw::Appearance::make(151);
constexpr nw::Appearance appearance_type_slaad_death = nw::Appearance::make(152);
constexpr nw::Appearance appearance_type_slaad_gray = nw::Appearance::make(153);
constexpr nw::Appearance appearance_type_slaad_green = nw::Appearance::make(154);
constexpr nw::Appearance appearance_type_slaad_red = nw::Appearance::make(155);
constexpr nw::Appearance appearance_type_spectre = nw::Appearance::make(156);
constexpr nw::Appearance appearance_type_sphinx = nw::Appearance::make(364);
constexpr nw::Appearance appearance_type_spider_dire = nw::Appearance::make(158);
constexpr nw::Appearance appearance_type_spider_giant = nw::Appearance::make(159);
constexpr nw::Appearance appearance_type_spider_phase = nw::Appearance::make(160);
constexpr nw::Appearance appearance_type_spider_sword = nw::Appearance::make(161);
constexpr nw::Appearance appearance_type_spider_wraith = nw::Appearance::make(162);
constexpr nw::Appearance appearance_type_stinger = nw::Appearance::make(356);
constexpr nw::Appearance appearance_type_stinger_chieftain = nw::Appearance::make(358);
constexpr nw::Appearance appearance_type_stinger_mage = nw::Appearance::make(359);
constexpr nw::Appearance appearance_type_stinger_warrior = nw::Appearance::make(357);
constexpr nw::Appearance appearance_type_succubus = nw::Appearance::make(163);
constexpr nw::Appearance appearance_type_troglodyte = nw::Appearance::make(451);
constexpr nw::Appearance appearance_type_troglodyte_warrior = nw::Appearance::make(452);
constexpr nw::Appearance appearance_type_troglodyte_cleric = nw::Appearance::make(453);
constexpr nw::Appearance appearance_type_troll = nw::Appearance::make(167);
constexpr nw::Appearance appearance_type_troll_chieftain = nw::Appearance::make(164);
constexpr nw::Appearance appearance_type_troll_shaman = nw::Appearance::make(165);
constexpr nw::Appearance appearance_type_umberhulk = nw::Appearance::make(168);
constexpr nw::Appearance appearance_type_uthgard_elk_tribe = nw::Appearance::make(213);
constexpr nw::Appearance appearance_type_uthgard_tiger_tribe = nw::Appearance::make(214);
constexpr nw::Appearance appearance_type_vampire_female = nw::Appearance::make(288);
constexpr nw::Appearance appearance_type_vampire_male = nw::Appearance::make(289);
constexpr nw::Appearance appearance_type_vrock = nw::Appearance::make(101);
constexpr nw::Appearance appearance_type_waitress = nw::Appearance::make(235);
constexpr nw::Appearance appearance_type_war_devourer = nw::Appearance::make(54);
constexpr nw::Appearance appearance_type_werecat = nw::Appearance::make(99);
constexpr nw::Appearance appearance_type_wererat = nw::Appearance::make(170);
constexpr nw::Appearance appearance_type_werewolf = nw::Appearance::make(171);
constexpr nw::Appearance appearance_type_wight = nw::Appearance::make(172);
constexpr nw::Appearance appearance_type_will_o_wisp = nw::Appearance::make(116);
constexpr nw::Appearance appearance_type_wraith = nw::Appearance::make(187);
constexpr nw::Appearance appearance_type_wyrmling_black = nw::Appearance::make(378);
constexpr nw::Appearance appearance_type_wyrmling_blue = nw::Appearance::make(377);
constexpr nw::Appearance appearance_type_wyrmling_brass = nw::Appearance::make(381);
constexpr nw::Appearance appearance_type_wyrmling_bronze = nw::Appearance::make(383);
constexpr nw::Appearance appearance_type_wyrmling_copper = nw::Appearance::make(382);
constexpr nw::Appearance appearance_type_wyrmling_gold = nw::Appearance::make(385);
constexpr nw::Appearance appearance_type_wyrmling_green = nw::Appearance::make(379);
constexpr nw::Appearance appearance_type_wyrmling_red = nw::Appearance::make(376);
constexpr nw::Appearance appearance_type_wyrmling_silver = nw::Appearance::make(384);
constexpr nw::Appearance appearance_type_wyrmling_white = nw::Appearance::make(380);
constexpr nw::Appearance appearance_type_yuan_ti = nw::Appearance::make(285);
constexpr nw::Appearance appearance_type_yuan_ti_chieften = nw::Appearance::make(286);
constexpr nw::Appearance appearance_type_yuan_ti_wizard = nw::Appearance::make(287);
constexpr nw::Appearance appearance_type_zombie = nw::Appearance::make(198);
constexpr nw::Appearance appearance_type_zombie_rotting = nw::Appearance::make(195);
constexpr nw::Appearance appearance_type_zombie_tyrant_fog = nw::Appearance::make(199);
constexpr nw::Appearance appearance_type_zombie_warrior_1 = nw::Appearance::make(196);
constexpr nw::Appearance appearance_type_zombie_warrior_2 = nw::Appearance::make(197);
constexpr nw::Appearance appearance_type_beholder = nw::Appearance::make(401);
constexpr nw::Appearance appearance_type_beholder_mage = nw::Appearance::make(402);
constexpr nw::Appearance appearance_type_beholder_eyeball = nw::Appearance::make(403);
constexpr nw::Appearance appearance_type_mephisto_big = nw::Appearance::make(404);
constexpr nw::Appearance appearance_type_dracolich = nw::Appearance::make(405);
constexpr nw::Appearance appearance_type_drider = nw::Appearance::make(406);
constexpr nw::Appearance appearance_type_drider_chief = nw::Appearance::make(407);
constexpr nw::Appearance appearance_type_drow_slave = nw::Appearance::make(408);
constexpr nw::Appearance appearance_type_drow_wizard = nw::Appearance::make(409);
constexpr nw::Appearance appearance_type_drow_matron = nw::Appearance::make(410);
constexpr nw::Appearance appearance_type_duergar_slave = nw::Appearance::make(411);
constexpr nw::Appearance appearance_type_duergar_chief = nw::Appearance::make(412);
constexpr nw::Appearance appearance_type_mindflayer = nw::Appearance::make(413);
constexpr nw::Appearance appearance_type_mindflayer_2 = nw::Appearance::make(414);
constexpr nw::Appearance appearance_type_mindflayer_alhoon = nw::Appearance::make(415);
constexpr nw::Appearance appearance_type_deep_rothe = nw::Appearance::make(416);
constexpr nw::Appearance appearance_type_dragon_shadow = nw::Appearance::make(418);
constexpr nw::Appearance appearance_type_harpy = nw::Appearance::make(419);
constexpr nw::Appearance appearance_type_golem_mithral = nw::Appearance::make(420);
constexpr nw::Appearance appearance_type_golem_adamantium = nw::Appearance::make(421);
constexpr nw::Appearance appearance_type_spider_demon = nw::Appearance::make(422);
constexpr nw::Appearance appearance_type_svirf_male = nw::Appearance::make(423);
constexpr nw::Appearance appearance_type_svirf_female = nw::Appearance::make(424);
constexpr nw::Appearance appearance_type_dragon_pris = nw::Appearance::make(425);
constexpr nw::Appearance appearance_type_slaad_black = nw::Appearance::make(426);
constexpr nw::Appearance appearance_type_slaad_white = nw::Appearance::make(427);
constexpr nw::Appearance appearance_type_azer_male = nw::Appearance::make(428);
constexpr nw::Appearance appearance_type_azer_female = nw::Appearance::make(429);
constexpr nw::Appearance appearance_type_demi_lich = nw::Appearance::make(430);
constexpr nw::Appearance appearance_type_object_chair = nw::Appearance::make(431);
constexpr nw::Appearance appearance_type_object_table = nw::Appearance::make(432);
constexpr nw::Appearance appearance_type_object_candle = nw::Appearance::make(433);
constexpr nw::Appearance appearance_type_object_chest = nw::Appearance::make(434);
constexpr nw::Appearance appearance_type_object_white = nw::Appearance::make(435);
constexpr nw::Appearance appearance_type_object_blue = nw::Appearance::make(436);
constexpr nw::Appearance appearance_type_object_cyan = nw::Appearance::make(437);
constexpr nw::Appearance appearance_type_object_green = nw::Appearance::make(438);
constexpr nw::Appearance appearance_type_object_yellow = nw::Appearance::make(439);
constexpr nw::Appearance appearance_type_object_orange = nw::Appearance::make(440);
constexpr nw::Appearance appearance_type_object_red = nw::Appearance::make(441);
constexpr nw::Appearance appearance_type_object_purple = nw::Appearance::make(442);
constexpr nw::Appearance appearance_type_object_flame_small = nw::Appearance::make(443);
constexpr nw::Appearance appearance_type_object_flame_medium = nw::Appearance::make(444);
constexpr nw::Appearance appearance_type_object_flame_large = nw::Appearance::make(445);
constexpr nw::Appearance appearance_type_drider_female = nw::Appearance::make(446);
constexpr nw::Appearance appearance_type_sea_hag = nw::Appearance::make(454);
constexpr nw::Appearance appearance_type_golem_demonflesh = nw::Appearance::make(468);
constexpr nw::Appearance appearance_type_animated_chest = nw::Appearance::make(469);
constexpr nw::Appearance appearance_type_gelatinous_cube = nw::Appearance::make(470);
constexpr nw::Appearance appearance_type_mephisto_norm = nw::Appearance::make(471);
constexpr nw::Appearance appearance_type_beholder_mother = nw::Appearance::make(472);
constexpr nw::Appearance appearance_type_object_boat = nw::Appearance::make(473);
constexpr nw::Appearance appearance_type_dwarf_golem = nw::Appearance::make(474);
constexpr nw::Appearance appearance_type_dwarf_halforc = nw::Appearance::make(475);
constexpr nw::Appearance appearance_type_drow_warrior_1 = nw::Appearance::make(476);
constexpr nw::Appearance appearance_type_drow_warrior_2 = nw::Appearance::make(477);
constexpr nw::Appearance appearance_type_drow_female_1 = nw::Appearance::make(478);
constexpr nw::Appearance appearance_type_drow_female_2 = nw::Appearance::make(479);
constexpr nw::Appearance appearance_type_drow_warrior_3 = nw::Appearance::make(480);

constexpr nw::ArmorClass ac_dodge = nw::ArmorClass::make(0);
constexpr nw::ArmorClass ac_natural = nw::ArmorClass::make(1);
constexpr nw::ArmorClass ac_armor = nw::ArmorClass::make(2);
constexpr nw::ArmorClass ac_shield = nw::ArmorClass::make(3);
constexpr nw::ArmorClass ac_deflection = nw::ArmorClass::make(4);

constexpr nw::AttackType attack_type_any = nw::AttackType::make(0);
constexpr nw::AttackType attack_type_onhand = nw::AttackType::make(1);
constexpr nw::AttackType attack_type_offhand = nw::AttackType::make(2);
constexpr nw::AttackType attack_type_unarmed = nw::AttackType::make(3);
constexpr nw::AttackType attack_type_cweapon1 = nw::AttackType::make(4);
constexpr nw::AttackType attack_type_cweapon2 = nw::AttackType::make(5);
constexpr nw::AttackType attack_type_cweapon3 = nw::AttackType::make(6);

constexpr nw::BaseItem base_item_shortsword = nw::BaseItem::make(0);
constexpr nw::BaseItem base_item_longsword = nw::BaseItem::make(1);
constexpr nw::BaseItem base_item_battleaxe = nw::BaseItem::make(2);
constexpr nw::BaseItem base_item_bastardsword = nw::BaseItem::make(3);
constexpr nw::BaseItem base_item_lightflail = nw::BaseItem::make(4);
constexpr nw::BaseItem base_item_warhammer = nw::BaseItem::make(5);
constexpr nw::BaseItem base_item_heavycrossbow = nw::BaseItem::make(6);
constexpr nw::BaseItem base_item_lightcrossbow = nw::BaseItem::make(7);
constexpr nw::BaseItem base_item_longbow = nw::BaseItem::make(8);
constexpr nw::BaseItem base_item_lightmace = nw::BaseItem::make(9);
constexpr nw::BaseItem base_item_halberd = nw::BaseItem::make(10);
constexpr nw::BaseItem base_item_shortbow = nw::BaseItem::make(11);
constexpr nw::BaseItem base_item_twobladedsword = nw::BaseItem::make(12);
constexpr nw::BaseItem base_item_greatsword = nw::BaseItem::make(13);
constexpr nw::BaseItem base_item_smallshield = nw::BaseItem::make(14);
constexpr nw::BaseItem base_item_torch = nw::BaseItem::make(15);
constexpr nw::BaseItem base_item_armor = nw::BaseItem::make(16);
constexpr nw::BaseItem base_item_helmet = nw::BaseItem::make(17);
constexpr nw::BaseItem base_item_greataxe = nw::BaseItem::make(18);
constexpr nw::BaseItem base_item_amulet = nw::BaseItem::make(19);
constexpr nw::BaseItem base_item_arrow = nw::BaseItem::make(20);
constexpr nw::BaseItem base_item_belt = nw::BaseItem::make(21);
constexpr nw::BaseItem base_item_dagger = nw::BaseItem::make(22);
constexpr nw::BaseItem base_item_miscsmall = nw::BaseItem::make(24);
constexpr nw::BaseItem base_item_bolt = nw::BaseItem::make(25);
constexpr nw::BaseItem base_item_boots = nw::BaseItem::make(26);
constexpr nw::BaseItem base_item_bullet = nw::BaseItem::make(27);
constexpr nw::BaseItem base_item_club = nw::BaseItem::make(28);
constexpr nw::BaseItem base_item_miscmedium = nw::BaseItem::make(29);
constexpr nw::BaseItem base_item_dart = nw::BaseItem::make(31);
constexpr nw::BaseItem base_item_diremace = nw::BaseItem::make(32);
constexpr nw::BaseItem base_item_doubleaxe = nw::BaseItem::make(33);
constexpr nw::BaseItem base_item_misclarge = nw::BaseItem::make(34);
constexpr nw::BaseItem base_item_heavyflail = nw::BaseItem::make(35);
constexpr nw::BaseItem base_item_gloves = nw::BaseItem::make(36);
constexpr nw::BaseItem base_item_lighthammer = nw::BaseItem::make(37);
constexpr nw::BaseItem base_item_handaxe = nw::BaseItem::make(38);
constexpr nw::BaseItem base_item_healerskit = nw::BaseItem::make(39);
constexpr nw::BaseItem base_item_kama = nw::BaseItem::make(40);
constexpr nw::BaseItem base_item_katana = nw::BaseItem::make(41);
constexpr nw::BaseItem base_item_kukri = nw::BaseItem::make(42);
constexpr nw::BaseItem base_item_misctall = nw::BaseItem::make(43);
constexpr nw::BaseItem base_item_magicrod = nw::BaseItem::make(44);
constexpr nw::BaseItem base_item_magicstaff = nw::BaseItem::make(45);
constexpr nw::BaseItem base_item_magicwand = nw::BaseItem::make(46);
constexpr nw::BaseItem base_item_morningstar = nw::BaseItem::make(47);
constexpr nw::BaseItem base_item_potions = nw::BaseItem::make(49);
constexpr nw::BaseItem base_item_quarterstaff = nw::BaseItem::make(50);
constexpr nw::BaseItem base_item_rapier = nw::BaseItem::make(51);
constexpr nw::BaseItem base_item_ring = nw::BaseItem::make(52);
constexpr nw::BaseItem base_item_scimitar = nw::BaseItem::make(53);
constexpr nw::BaseItem base_item_scroll = nw::BaseItem::make(54);
constexpr nw::BaseItem base_item_scythe = nw::BaseItem::make(55);
constexpr nw::BaseItem base_item_largeshield = nw::BaseItem::make(56);
constexpr nw::BaseItem base_item_towershield = nw::BaseItem::make(57);
constexpr nw::BaseItem base_item_shortspear = nw::BaseItem::make(58);
constexpr nw::BaseItem base_item_shuriken = nw::BaseItem::make(59);
constexpr nw::BaseItem base_item_sickle = nw::BaseItem::make(60);
constexpr nw::BaseItem base_item_sling = nw::BaseItem::make(61);
constexpr nw::BaseItem base_item_thievestools = nw::BaseItem::make(62);
constexpr nw::BaseItem base_item_throwingaxe = nw::BaseItem::make(63);
constexpr nw::BaseItem base_item_trapkit = nw::BaseItem::make(64);
constexpr nw::BaseItem base_item_key = nw::BaseItem::make(65);
constexpr nw::BaseItem base_item_largebox = nw::BaseItem::make(66);
constexpr nw::BaseItem base_item_miscwide = nw::BaseItem::make(68);
constexpr nw::BaseItem base_item_cslashweapon = nw::BaseItem::make(69);
constexpr nw::BaseItem base_item_cpiercweapon = nw::BaseItem::make(70);
constexpr nw::BaseItem base_item_cbludgweapon = nw::BaseItem::make(71);
constexpr nw::BaseItem base_item_cslshprcweap = nw::BaseItem::make(72);
constexpr nw::BaseItem base_item_creatureitem = nw::BaseItem::make(73);
constexpr nw::BaseItem base_item_book = nw::BaseItem::make(74);
constexpr nw::BaseItem base_item_spellscroll = nw::BaseItem::make(75);
constexpr nw::BaseItem base_item_gold = nw::BaseItem::make(76);
constexpr nw::BaseItem base_item_gem = nw::BaseItem::make(77);
constexpr nw::BaseItem base_item_bracer = nw::BaseItem::make(78);
constexpr nw::BaseItem base_item_miscthin = nw::BaseItem::make(79);
constexpr nw::BaseItem base_item_cloak = nw::BaseItem::make(80);
constexpr nw::BaseItem base_item_grenade = nw::BaseItem::make(81);
constexpr nw::BaseItem base_item_trident = nw::BaseItem::make(95);
constexpr nw::BaseItem base_item_blank_potion = nw::BaseItem::make(101);
constexpr nw::BaseItem base_item_blank_scroll = nw::BaseItem::make(102);
constexpr nw::BaseItem base_item_blank_wand = nw::BaseItem::make(103);
constexpr nw::BaseItem base_item_enchanted_potion = nw::BaseItem::make(104);
constexpr nw::BaseItem base_item_enchanted_scroll = nw::BaseItem::make(105);
constexpr nw::BaseItem base_item_enchanted_wand = nw::BaseItem::make(106);
constexpr nw::BaseItem base_item_dwarvenwaraxe = nw::BaseItem::make(108);
constexpr nw::BaseItem base_item_craftmaterialmed = nw::BaseItem::make(109);
constexpr nw::BaseItem base_item_craftmaterialsml = nw::BaseItem::make(110);
constexpr nw::BaseItem base_item_whip = nw::BaseItem::make(111);

constexpr nw::Class class_type_barbarian = nw::Class::make(0);
constexpr nw::Class class_type_bard = nw::Class::make(1);
constexpr nw::Class class_type_cleric = nw::Class::make(2);
constexpr nw::Class class_type_druid = nw::Class::make(3);
constexpr nw::Class class_type_fighter = nw::Class::make(4);
constexpr nw::Class class_type_monk = nw::Class::make(5);
constexpr nw::Class class_type_paladin = nw::Class::make(6);
constexpr nw::Class class_type_ranger = nw::Class::make(7);
constexpr nw::Class class_type_rogue = nw::Class::make(8);
constexpr nw::Class class_type_sorcerer = nw::Class::make(9);
constexpr nw::Class class_type_wizard = nw::Class::make(10);
constexpr nw::Class class_type_aberration = nw::Class::make(11);
constexpr nw::Class class_type_animal = nw::Class::make(12);
constexpr nw::Class class_type_construct = nw::Class::make(13);
constexpr nw::Class class_type_humanoid = nw::Class::make(14);
constexpr nw::Class class_type_monstrous = nw::Class::make(15);
constexpr nw::Class class_type_elemental = nw::Class::make(16);
constexpr nw::Class class_type_fey = nw::Class::make(17);
constexpr nw::Class class_type_dragon = nw::Class::make(18);
constexpr nw::Class class_type_undead = nw::Class::make(19);
constexpr nw::Class class_type_commoner = nw::Class::make(20);
constexpr nw::Class class_type_beast = nw::Class::make(21);
constexpr nw::Class class_type_giant = nw::Class::make(22);
constexpr nw::Class class_type_magical_beast = nw::Class::make(23);
constexpr nw::Class class_type_outsider = nw::Class::make(24);
constexpr nw::Class class_type_shapechanger = nw::Class::make(25);
constexpr nw::Class class_type_vermin = nw::Class::make(26);
constexpr nw::Class class_type_shadowdancer = nw::Class::make(27);
constexpr nw::Class class_type_harper = nw::Class::make(28);
constexpr nw::Class class_type_arcane_archer = nw::Class::make(29);
constexpr nw::Class class_type_assassin = nw::Class::make(30);
constexpr nw::Class class_type_blackguard = nw::Class::make(31);
constexpr nw::Class class_type_divinechampion = nw::Class::make(32);
constexpr nw::Class class_type_divine_champion = nw::Class::make(32);
constexpr nw::Class class_type_weapon_master = nw::Class::make(33);
constexpr nw::Class class_type_palemaster = nw::Class::make(34);
constexpr nw::Class class_type_pale_master = nw::Class::make(34);
constexpr nw::Class class_type_shifter = nw::Class::make(35);
constexpr nw::Class class_type_dwarvendefender = nw::Class::make(36);
constexpr nw::Class class_type_dwarven_defender = nw::Class::make(36);
constexpr nw::Class class_type_dragondisciple = nw::Class::make(37);
constexpr nw::Class class_type_dragon_disciple = nw::Class::make(37);
constexpr nw::Class class_type_ooze = nw::Class::make(38);
constexpr nw::Class class_type_eye_of_gruumsh = nw::Class::make(39);
constexpr nw::Class class_type_shou_disciple = nw::Class::make(40);
constexpr nw::Class class_type_purple_dragon_knight = nw::Class::make(41);

constexpr nw::CombatMode combat_mode_parry = nw::CombatMode::make(1);
constexpr nw::CombatMode combat_mode_power_attack = nw::CombatMode::make(2);
constexpr nw::CombatMode combat_mode_improved_power_attack = nw::CombatMode::make(3);
constexpr nw::CombatMode combat_mode_counter_spell = nw::CombatMode::make(4);
constexpr nw::CombatMode combat_mode_flurry_of_blows = nw::CombatMode::make(5);
constexpr nw::CombatMode combat_mode_rapid_shot = nw::CombatMode::make(6);
constexpr nw::CombatMode combat_mode_expertise = nw::CombatMode::make(7);
constexpr nw::CombatMode combat_mode_improved_expertise = nw::CombatMode::make(8);
constexpr nw::CombatMode combat_mode_defensive_casting = nw::CombatMode::make(9);
constexpr nw::CombatMode combat_mode_dirty_fighting = nw::CombatMode::make(10);
constexpr nw::CombatMode combat_mode_defensive_stance = nw::CombatMode::make(11);

constexpr int creature_size_invalid = 0;
constexpr int creature_size_tiny = 1;
constexpr int creature_size_small = 2;
constexpr int creature_size_medium = 3;
constexpr int creature_size_large = 4;
constexpr int creature_size_huge = 5;

constexpr nw::Disease disease_blinding_sickness = nw::Disease::make(0);
constexpr nw::Disease disease_cackle_fever = nw::Disease::make(1);
constexpr nw::Disease disease_devil_chills = nw::Disease::make(2);
constexpr nw::Disease disease_demon_fever = nw::Disease::make(3);
constexpr nw::Disease disease_filth_fever = nw::Disease::make(4);
constexpr nw::Disease disease_mindfire = nw::Disease::make(5);
constexpr nw::Disease disease_mummy_rot = nw::Disease::make(6);
constexpr nw::Disease disease_red_ache = nw::Disease::make(7);
constexpr nw::Disease disease_shakes = nw::Disease::make(8);
constexpr nw::Disease disease_slimy_doom = nw::Disease::make(9);
constexpr nw::Disease disease_red_slaad_eggs = nw::Disease::make(10);
constexpr nw::Disease disease_ghoul_rot = nw::Disease::make(11);
constexpr nw::Disease disease_zombie_creep = nw::Disease::make(12);
constexpr nw::Disease disease_dread_blisters = nw::Disease::make(13);
constexpr nw::Disease disease_burrow_maggots = nw::Disease::make(14);
constexpr nw::Disease disease_soldier_shakes = nw::Disease::make(15);
constexpr nw::Disease disease_vermin_madness = nw::Disease::make(16);

constexpr nw::EffectType effect_type_haste = nw::EffectType::make(1);
constexpr nw::EffectType effect_type_damage_resistance = nw::EffectType::make(2);
constexpr nw::EffectType effect_type_slow = nw::EffectType::make(3);
constexpr nw::EffectType effect_type_resurrection = nw::EffectType::make(4);
constexpr nw::EffectType effect_type_disease = nw::EffectType::make(5);
constexpr nw::EffectType effect_type_summon_creature = nw::EffectType::make(6);
constexpr nw::EffectType effect_type_regenerate = nw::EffectType::make(7);
constexpr nw::EffectType effect_type_setstate = nw::EffectType::make(8);
constexpr nw::EffectType effect_type_setstate_internal = nw::EffectType::make(9);
constexpr nw::EffectType effect_type_attack_increase = nw::EffectType::make(10);
constexpr nw::EffectType effect_type_attack_decrease = nw::EffectType::make(11);
constexpr nw::EffectType effect_type_damage_reduction = nw::EffectType::make(12);
constexpr nw::EffectType effect_type_damage_increase = nw::EffectType::make(13);
constexpr nw::EffectType effect_type_damage_decrease = nw::EffectType::make(14);
constexpr nw::EffectType effect_type_temporary_hitpoints = nw::EffectType::make(15);
constexpr nw::EffectType effect_type_damage_immunity_increase = nw::EffectType::make(16);
constexpr nw::EffectType effect_type_damage_immunity_decrease = nw::EffectType::make(17);
constexpr nw::EffectType effect_type_entangle = nw::EffectType::make(18);
constexpr nw::EffectType effect_type_death = nw::EffectType::make(19);
constexpr nw::EffectType effect_type_knockdown = nw::EffectType::make(20);
constexpr nw::EffectType effect_type_deaf = nw::EffectType::make(21);
constexpr nw::EffectType effect_type_immunity = nw::EffectType::make(22);
constexpr nw::EffectType effect_type_set_ai_state = nw::EffectType::make(23);
constexpr nw::EffectType effect_type_enemy_attack_bonus = nw::EffectType::make(24);
constexpr nw::EffectType effect_type_arcane_spell_failure = nw::EffectType::make(25);
constexpr nw::EffectType effect_type_saving_throw_increase = nw::EffectType::make(26);
constexpr nw::EffectType effect_type_saving_throw_decrease = nw::EffectType::make(27);
constexpr nw::EffectType effect_type_movement_speed_increase = nw::EffectType::make(28);
constexpr nw::EffectType effect_type_movement_speed_decrease = nw::EffectType::make(29);
constexpr nw::EffectType effect_type_visualeffect = nw::EffectType::make(30);
constexpr nw::EffectType effect_type_area_of_effect = nw::EffectType::make(31);
constexpr nw::EffectType effect_type_beam = nw::EffectType::make(32);
constexpr nw::EffectType effect_type_spell_resistance_increase = nw::EffectType::make(33);
constexpr nw::EffectType effect_type_spell_resistance_decrease = nw::EffectType::make(34);
constexpr nw::EffectType effect_type_poison = nw::EffectType::make(35);
constexpr nw::EffectType effect_type_ability_increase = nw::EffectType::make(36);
constexpr nw::EffectType effect_type_ability_decrease = nw::EffectType::make(37);
constexpr nw::EffectType effect_type_damage = nw::EffectType::make(38);
constexpr nw::EffectType effect_type_heal = nw::EffectType::make(39);
constexpr nw::EffectType effect_type_link = nw::EffectType::make(40);
constexpr nw::EffectType effect_type_haste_internal = nw::EffectType::make(41);
constexpr nw::EffectType effect_type_slow_internal = nw::EffectType::make(42);
constexpr nw::EffectType effect_type_modifynumattacks = nw::EffectType::make(44);
constexpr nw::EffectType effect_type_curse = nw::EffectType::make(45);
constexpr nw::EffectType effect_type_silence = nw::EffectType::make(46);
constexpr nw::EffectType effect_type_invisibility = nw::EffectType::make(47);
constexpr nw::EffectType effect_type_ac_increase = nw::EffectType::make(48);
constexpr nw::EffectType effect_type_ac_decrease = nw::EffectType::make(49);
constexpr nw::EffectType effect_type_spell_immunity = nw::EffectType::make(50);
constexpr nw::EffectType effect_type_dispel_all_magic = nw::EffectType::make(51);
constexpr nw::EffectType effect_type_dispel_best_magic = nw::EffectType::make(52);
constexpr nw::EffectType effect_type_taunt = nw::EffectType::make(53);
constexpr nw::EffectType effect_type_light = nw::EffectType::make(54);
constexpr nw::EffectType effect_type_skill_increase = nw::EffectType::make(55);
constexpr nw::EffectType effect_type_skill_decrease = nw::EffectType::make(56);
constexpr nw::EffectType effect_type_hitpointchangewhendying = nw::EffectType::make(57);
constexpr nw::EffectType effect_type_setwalkanimation = nw::EffectType::make(58);
constexpr nw::EffectType effect_type_limit_movement_speed = nw::EffectType::make(59);
constexpr nw::EffectType effect_type_damage_shield = nw::EffectType::make(61);
constexpr nw::EffectType effect_type_polymorph = nw::EffectType::make(62);
constexpr nw::EffectType effect_type_sanctuary = nw::EffectType::make(63);
constexpr nw::EffectType effect_type_timestop = nw::EffectType::make(64);
constexpr nw::EffectType effect_type_spell_level_absorption = nw::EffectType::make(65);
constexpr nw::EffectType effect_type_icon = nw::EffectType::make(67);
constexpr nw::EffectType effect_type_racial_type = nw::EffectType::make(68);
constexpr nw::EffectType effect_type_vision = nw::EffectType::make(69);
constexpr nw::EffectType effect_type_seeinvisible = nw::EffectType::make(70);
constexpr nw::EffectType effect_type_ultravision = nw::EffectType::make(71);
constexpr nw::EffectType effect_type_trueseeing = nw::EffectType::make(72);
constexpr nw::EffectType effect_type_blindness = nw::EffectType::make(73);
constexpr nw::EffectType effect_type_darkness = nw::EffectType::make(74);
constexpr nw::EffectType effect_type_miss_chance = nw::EffectType::make(75);
constexpr nw::EffectType effect_type_concealment = nw::EffectType::make(76);
constexpr nw::EffectType effect_type_turn_resistance_increase = nw::EffectType::make(77);
constexpr nw::EffectType effect_type_bonus_spell_of_level = nw::EffectType::make(78);
constexpr nw::EffectType effect_type_disappearappear = nw::EffectType::make(79);
constexpr nw::EffectType effect_type_disappear = nw::EffectType::make(80);
constexpr nw::EffectType effect_type_appear = nw::EffectType::make(81);
constexpr nw::EffectType effect_type_negative_level = nw::EffectType::make(82);
constexpr nw::EffectType effect_type_bonus_feat = nw::EffectType::make(83);
constexpr nw::EffectType effect_type_wounding = nw::EffectType::make(84);
constexpr nw::EffectType effect_type_swarm = nw::EffectType::make(85);
constexpr nw::EffectType effect_type_vampiric_regeneration = nw::EffectType::make(86);
constexpr nw::EffectType effect_type_disarm = nw::EffectType::make(87);
constexpr nw::EffectType effect_type_turn_resistance_decrease = nw::EffectType::make(88);
constexpr nw::EffectType effect_type_blindness_inactive = nw::EffectType::make(89);
constexpr nw::EffectType effect_type_petrify = nw::EffectType::make(90);
constexpr nw::EffectType effect_type_item_property = nw::EffectType::make(91);
constexpr nw::EffectType effect_type_spell_failure = nw::EffectType::make(92);
constexpr nw::EffectType effect_type_cutscene_ghost = nw::EffectType::make(93);
constexpr nw::EffectType effect_type_cutscene_immobile = nw::EffectType::make(94);
constexpr nw::EffectType effect_type_defensive_stance = nw::EffectType::make(95);

constexpr nw::ItemPropertyType ip_ability_bonus = nw::ItemPropertyType::make(0);
constexpr nw::ItemPropertyType ip_ac_bonus = nw::ItemPropertyType::make(1);
constexpr nw::ItemPropertyType ip_ac_bonus_vs_alignment_group = nw::ItemPropertyType::make(2);
constexpr nw::ItemPropertyType ip_ac_bonus_vs_damage_type = nw::ItemPropertyType::make(3);
constexpr nw::ItemPropertyType ip_ac_bonus_vs_racial_group = nw::ItemPropertyType::make(4);
constexpr nw::ItemPropertyType ip_ac_bonus_vs_specific_alignment = nw::ItemPropertyType::make(5);
constexpr nw::ItemPropertyType ip_enhancement_bonus = nw::ItemPropertyType::make(6);
constexpr nw::ItemPropertyType ip_enhancement_bonus_vs_alignment_group = nw::ItemPropertyType::make(7);
constexpr nw::ItemPropertyType ip_enhancement_bonus_vs_racial_group = nw::ItemPropertyType::make(8);
constexpr nw::ItemPropertyType ip_enhancement_bonus_vs_specific_alignement = nw::ItemPropertyType::make(9);
constexpr nw::ItemPropertyType ip_enhancement_penalty = nw::ItemPropertyType::make(10);
constexpr nw::ItemPropertyType ip_base_item_weight_reduction = nw::ItemPropertyType::make(11);
constexpr nw::ItemPropertyType ip_bonus_feat = nw::ItemPropertyType::make(12);
constexpr nw::ItemPropertyType ip_bonus_spell_slot_of_level_n = nw::ItemPropertyType::make(13);
constexpr nw::ItemPropertyType ip_cast_spell = nw::ItemPropertyType::make(15);
constexpr nw::ItemPropertyType ip_damage_bonus = nw::ItemPropertyType::make(16);
constexpr nw::ItemPropertyType ip_damage_bonus_vs_alignment_group = nw::ItemPropertyType::make(17);
constexpr nw::ItemPropertyType ip_damage_bonus_vs_racial_group = nw::ItemPropertyType::make(18);
constexpr nw::ItemPropertyType ip_damage_bonus_vs_specific_alignment = nw::ItemPropertyType::make(19);
constexpr nw::ItemPropertyType ip_immunity_damage_type = nw::ItemPropertyType::make(20);
constexpr nw::ItemPropertyType ip_decreased_damage = nw::ItemPropertyType::make(21);
constexpr nw::ItemPropertyType ip_damage_reduction = nw::ItemPropertyType::make(22);
constexpr nw::ItemPropertyType ip_damage_resistance = nw::ItemPropertyType::make(23);
constexpr nw::ItemPropertyType ip_damage_vulnerability = nw::ItemPropertyType::make(24);
constexpr nw::ItemPropertyType ip_darkvision = nw::ItemPropertyType::make(26);
constexpr nw::ItemPropertyType ip_decreased_ability_score = nw::ItemPropertyType::make(27);
constexpr nw::ItemPropertyType ip_decreased_ac = nw::ItemPropertyType::make(28);
constexpr nw::ItemPropertyType ip_decreased_skill_modifier = nw::ItemPropertyType::make(29);
constexpr nw::ItemPropertyType ip_enhanced_container_reduced_weight = nw::ItemPropertyType::make(32);
constexpr nw::ItemPropertyType ip_extra_melee_damage_type = nw::ItemPropertyType::make(33);
constexpr nw::ItemPropertyType ip_extra_ranged_damage_type = nw::ItemPropertyType::make(34);
constexpr nw::ItemPropertyType ip_haste = nw::ItemPropertyType::make(35);
constexpr nw::ItemPropertyType ip_holy_avenger = nw::ItemPropertyType::make(36);
constexpr nw::ItemPropertyType ip_immunity_miscellaneous = nw::ItemPropertyType::make(37);
constexpr nw::ItemPropertyType ip_improved_evasion = nw::ItemPropertyType::make(38);
constexpr nw::ItemPropertyType ip_spell_resistance = nw::ItemPropertyType::make(39);
constexpr nw::ItemPropertyType ip_saving_throw_bonus = nw::ItemPropertyType::make(40);
constexpr nw::ItemPropertyType ip_saving_throw_bonus_specific = nw::ItemPropertyType::make(41);
constexpr nw::ItemPropertyType ip_keen = nw::ItemPropertyType::make(43);
constexpr nw::ItemPropertyType ip_light = nw::ItemPropertyType::make(44);
constexpr nw::ItemPropertyType ip_mighty = nw::ItemPropertyType::make(45);
constexpr nw::ItemPropertyType ip_mind_blank = nw::ItemPropertyType::make(46);
constexpr nw::ItemPropertyType ip_no_damage = nw::ItemPropertyType::make(47);
constexpr nw::ItemPropertyType ip_on_hit_properties = nw::ItemPropertyType::make(48);
constexpr nw::ItemPropertyType ip_decreased_saving_throws = nw::ItemPropertyType::make(49);
constexpr nw::ItemPropertyType ip_decreased_saving_throws_specific = nw::ItemPropertyType::make(50);
constexpr nw::ItemPropertyType ip_regeneration = nw::ItemPropertyType::make(51);
constexpr nw::ItemPropertyType ip_skill_bonus = nw::ItemPropertyType::make(52);
constexpr nw::ItemPropertyType ip_immunity_specific_spell = nw::ItemPropertyType::make(53);
constexpr nw::ItemPropertyType ip_immunity_spell_school = nw::ItemPropertyType::make(54);
constexpr nw::ItemPropertyType ip_thieves_tools = nw::ItemPropertyType::make(55);
constexpr nw::ItemPropertyType ip_attack_bonus = nw::ItemPropertyType::make(56);
constexpr nw::ItemPropertyType ip_attack_bonus_vs_alignment_group = nw::ItemPropertyType::make(57);
constexpr nw::ItemPropertyType ip_attack_bonus_vs_racial_group = nw::ItemPropertyType::make(58);
constexpr nw::ItemPropertyType ip_attack_bonus_vs_specific_alignment = nw::ItemPropertyType::make(59);
constexpr nw::ItemPropertyType ip_attack_penalty = nw::ItemPropertyType::make(60);
constexpr nw::ItemPropertyType ip_unlimited_ammunition = nw::ItemPropertyType::make(61);
constexpr nw::ItemPropertyType ip_use_limitation_alignment_group = nw::ItemPropertyType::make(62);
constexpr nw::ItemPropertyType ip_use_limitation_class = nw::ItemPropertyType::make(63);
constexpr nw::ItemPropertyType ip_use_limitation_racial_type = nw::ItemPropertyType::make(64);
constexpr nw::ItemPropertyType ip_use_limitation_specific_alignment = nw::ItemPropertyType::make(65);
constexpr nw::ItemPropertyType ip_use_limitation_tileset = nw::ItemPropertyType::make(66);
constexpr nw::ItemPropertyType ip_regeneration_vampiric = nw::ItemPropertyType::make(67);
constexpr nw::ItemPropertyType ip_trap = nw::ItemPropertyType::make(70);
constexpr nw::ItemPropertyType ip_true_seeing = nw::ItemPropertyType::make(71);
constexpr nw::ItemPropertyType ip_on_monster_hit = nw::ItemPropertyType::make(72);
constexpr nw::ItemPropertyType ip_turn_resistance = nw::ItemPropertyType::make(73);
constexpr nw::ItemPropertyType ip_massive_criticals = nw::ItemPropertyType::make(74);
constexpr nw::ItemPropertyType ip_freedom_of_movement = nw::ItemPropertyType::make(75);
constexpr nw::ItemPropertyType ip_monster_damage = nw::ItemPropertyType::make(77);
constexpr nw::ItemPropertyType ip_immunity_spells_by_level = nw::ItemPropertyType::make(78);
constexpr nw::ItemPropertyType ip_special_walk = nw::ItemPropertyType::make(79);
constexpr nw::ItemPropertyType ip_healers_kit = nw::ItemPropertyType::make(80);
constexpr nw::ItemPropertyType ip_weight_increase = nw::ItemPropertyType::make(81);
constexpr nw::ItemPropertyType ip_onhitcastspell = nw::ItemPropertyType::make(82);
constexpr nw::ItemPropertyType ip_visualeffect = nw::ItemPropertyType::make(83);
constexpr nw::ItemPropertyType ip_arcane_spell_failure = nw::ItemPropertyType::make(84);
constexpr nw::ItemPropertyType ip_material = nw::ItemPropertyType::make(85);
constexpr nw::ItemPropertyType ip_quality = nw::ItemPropertyType::make(86);
constexpr nw::ItemPropertyType ip_additional = nw::ItemPropertyType::make(87);

constexpr nw::Damage damage_type_bludgeoning = nw::Damage::make(0);
constexpr nw::Damage damage_type_piercing = nw::Damage::make(1);
constexpr nw::Damage damage_type_slashing = nw::Damage::make(2);
constexpr nw::Damage damage_type_magical = nw::Damage::make(3);
constexpr nw::Damage damage_type_acid = nw::Damage::make(4);
constexpr nw::Damage damage_type_cold = nw::Damage::make(5);
constexpr nw::Damage damage_type_divine = nw::Damage::make(6);
constexpr nw::Damage damage_type_electrical = nw::Damage::make(7);
constexpr nw::Damage damage_type_fire = nw::Damage::make(8);
constexpr nw::Damage damage_type_negative = nw::Damage::make(9);
constexpr nw::Damage damage_type_positive = nw::Damage::make(10);
constexpr nw::Damage damage_type_sonic = nw::Damage::make(11);
constexpr nw::Damage damage_type_base_weapon = nw::Damage::make(12);

constexpr nw::DamageModType damage_mod_immunity = nw::DamageModType::make(0);
constexpr nw::DamageModType damage_mod_resistance = nw::DamageModType::make(1);
constexpr nw::DamageModType damage_mod_reduction = nw::DamageModType::make(2);

extern const nw::DamageFlag damage_flag_bludgeoning;
extern const nw::DamageFlag damage_flag_piercing;
extern const nw::DamageFlag damage_flag_slashing;
extern const nw::DamageFlag damage_flag_magical;
extern const nw::DamageFlag damage_flag_acid;
extern const nw::DamageFlag damage_flag_cold;
extern const nw::DamageFlag damage_flag_divine;
extern const nw::DamageFlag damage_flag_electrical;
extern const nw::DamageFlag damage_flag_fire;
extern const nw::DamageFlag damage_flag_negative;
extern const nw::DamageFlag damage_flag_positive;
extern const nw::DamageFlag damage_flag_sonic;
extern const nw::DamageFlag damage_flag_base_weapon;

constexpr nw::Poison poison_nightshade = nw::Poison::make(0);
constexpr nw::Poison poison_small_centipede_poison = nw::Poison::make(1);
constexpr nw::Poison poison_blade_bane = nw::Poison::make(2);
constexpr nw::Poison poison_greenblood_oil = nw::Poison::make(3);
constexpr nw::Poison poison_bloodroot = nw::Poison::make(4);
constexpr nw::Poison poison_purple_worm_poison = nw::Poison::make(5);
constexpr nw::Poison poison_large_scorpion_venom = nw::Poison::make(6);
constexpr nw::Poison poison_wyvern_poison = nw::Poison::make(7);
constexpr nw::Poison poison_blue_whinnis = nw::Poison::make(8);
constexpr nw::Poison poison_giant_wasp_poison = nw::Poison::make(9);
constexpr nw::Poison poison_shadow_essence = nw::Poison::make(10);
constexpr nw::Poison poison_black_adder_venom = nw::Poison::make(11);
constexpr nw::Poison poison_deathblade = nw::Poison::make(12);
constexpr nw::Poison poison_malyss_root_paste = nw::Poison::make(13);
constexpr nw::Poison poison_nitharit = nw::Poison::make(14);
constexpr nw::Poison poison_dragon_bile = nw::Poison::make(15);
constexpr nw::Poison poison_sassone_leaf_residue = nw::Poison::make(16);
constexpr nw::Poison poison_terinav_root = nw::Poison::make(17);
constexpr nw::Poison poison_carrion_crawler_brain_juice = nw::Poison::make(18);
constexpr nw::Poison poison_black_lotus_extract = nw::Poison::make(19);
constexpr nw::Poison poison_oil_of_taggit = nw::Poison::make(20);
constexpr nw::Poison poison_id_moss = nw::Poison::make(21);
constexpr nw::Poison poison_striped_toadstool = nw::Poison::make(22);
constexpr nw::Poison poison_arsenic = nw::Poison::make(23);
constexpr nw::Poison poison_lich_dust = nw::Poison::make(24);
constexpr nw::Poison poison_dark_reaver_powder = nw::Poison::make(25);
constexpr nw::Poison poison_ungol_dust = nw::Poison::make(26);
constexpr nw::Poison poison_burnt_othur_fumes = nw::Poison::make(27);
constexpr nw::Poison poison_chaos_mist = nw::Poison::make(28);
constexpr nw::Poison poison_bebilith_venom = nw::Poison::make(29);
constexpr nw::Poison poison_quasit_venom = nw::Poison::make(30);
constexpr nw::Poison poison_pit_fiend_ichor = nw::Poison::make(31);
constexpr nw::Poison poison_ettercap_venom = nw::Poison::make(32);
constexpr nw::Poison poison_aranea_venom = nw::Poison::make(33);
constexpr nw::Poison poison_tiny_spider_venom = nw::Poison::make(34);
constexpr nw::Poison poison_small_spider_venom = nw::Poison::make(35);
constexpr nw::Poison poison_medium_spider_venom = nw::Poison::make(36);
constexpr nw::Poison poison_large_spider_venom = nw::Poison::make(37);
constexpr nw::Poison poison_huge_spider_venom = nw::Poison::make(38);
constexpr nw::Poison poison_gargantuan_spider_venom = nw::Poison::make(39);
constexpr nw::Poison poison_colossal_spider_venom = nw::Poison::make(40);
constexpr nw::Poison poison_phase_spider_venom = nw::Poison::make(41);
constexpr nw::Poison poison_wraith_spider_venom = nw::Poison::make(42);
constexpr nw::Poison poison_iron_golem = nw::Poison::make(43);

constexpr nw::Race racial_type_dwarf = nw::Race::make(0);
constexpr nw::Race racial_type_elf = nw::Race::make(1);
constexpr nw::Race racial_type_gnome = nw::Race::make(2);
constexpr nw::Race racial_type_halfling = nw::Race::make(3);
constexpr nw::Race racial_type_halfelf = nw::Race::make(4);
constexpr nw::Race racial_type_halforc = nw::Race::make(5);
constexpr nw::Race racial_type_human = nw::Race::make(6);
constexpr nw::Race racial_type_aberration = nw::Race::make(7);
constexpr nw::Race racial_type_animal = nw::Race::make(8);
constexpr nw::Race racial_type_beast = nw::Race::make(9);
constexpr nw::Race racial_type_construct = nw::Race::make(10);
constexpr nw::Race racial_type_dragon = nw::Race::make(11);
constexpr nw::Race racial_type_humanoid_goblinoid = nw::Race::make(12);
constexpr nw::Race racial_type_humanoid_monstrous = nw::Race::make(13);
constexpr nw::Race racial_type_humanoid_orc = nw::Race::make(14);
constexpr nw::Race racial_type_humanoid_reptilian = nw::Race::make(15);
constexpr nw::Race racial_type_elemental = nw::Race::make(16);
constexpr nw::Race racial_type_fey = nw::Race::make(17);
constexpr nw::Race racial_type_giant = nw::Race::make(18);
constexpr nw::Race racial_type_magical_beast = nw::Race::make(19);
constexpr nw::Race racial_type_outsider = nw::Race::make(20);
constexpr nw::Race racial_type_shapechanger = nw::Race::make(23);
constexpr nw::Race racial_type_undead = nw::Race::make(24);
constexpr nw::Race racial_type_vermin = nw::Race::make(25);
constexpr nw::Race racial_type_all = nw::Race::make(28);
constexpr nw::Race racial_type_invalid = nw::Race::make(28);
constexpr nw::Race racial_type_ooze = nw::Race::make(29);

constexpr nw::Situation situation_type_blind = nw::Situation::make(0);
constexpr nw::Situation situation_type_coup_de_grace = nw::Situation::make(1);
constexpr nw::Situation situation_type_death_attack = nw::Situation::make(2);
constexpr nw::Situation situation_type_flanked = nw::Situation::make(3);
constexpr nw::Situation situation_type_flat_footed = nw::Situation::make(4);
constexpr nw::Situation situation_type_sneak_attack = nw::Situation::make(5);

extern const nw::SituationFlag situation_flag_blind;
extern const nw::SituationFlag situation_flag_coup_de_grace;
extern const nw::SituationFlag situation_flag_death_attack;
extern const nw::SituationFlag situation_flag_flanked;
extern const nw::SituationFlag situation_flag_flat_footed;
extern const nw::SituationFlag situation_flag_sneak_attack;

constexpr nw::Skill skill_animal_empathy = nw::Skill::make(0);
constexpr nw::Skill skill_concentration = nw::Skill::make(1);
constexpr nw::Skill skill_disable_trap = nw::Skill::make(2);
constexpr nw::Skill skill_discipline = nw::Skill::make(3);
constexpr nw::Skill skill_heal = nw::Skill::make(4);
constexpr nw::Skill skill_hide = nw::Skill::make(5);
constexpr nw::Skill skill_listen = nw::Skill::make(6);
constexpr nw::Skill skill_lore = nw::Skill::make(7);
constexpr nw::Skill skill_move_silently = nw::Skill::make(8);
constexpr nw::Skill skill_open_lock = nw::Skill::make(9);
constexpr nw::Skill skill_parry = nw::Skill::make(10);
constexpr nw::Skill skill_perform = nw::Skill::make(11);
constexpr nw::Skill skill_persuade = nw::Skill::make(12);
constexpr nw::Skill skill_pick_pocket = nw::Skill::make(13);
constexpr nw::Skill skill_search = nw::Skill::make(14);
constexpr nw::Skill skill_set_trap = nw::Skill::make(15);
constexpr nw::Skill skill_spellcraft = nw::Skill::make(16);
constexpr nw::Skill skill_spot = nw::Skill::make(17);
constexpr nw::Skill skill_taunt = nw::Skill::make(18);
constexpr nw::Skill skill_use_magic_device = nw::Skill::make(19);
constexpr nw::Skill skill_appraise = nw::Skill::make(20);
constexpr nw::Skill skill_tumble = nw::Skill::make(21);
constexpr nw::Skill skill_craft_trap = nw::Skill::make(22);
constexpr nw::Skill skill_bluff = nw::Skill::make(23);
constexpr nw::Skill skill_intimidate = nw::Skill::make(24);
constexpr nw::Skill skill_craft_armor = nw::Skill::make(25);
constexpr nw::Skill skill_craft_weapon = nw::Skill::make(26);
constexpr nw::Skill skill_ride = nw::Skill::make(27);

constexpr nw::MissChanceType miss_chance_type_darkness = nw::MissChanceType::make(1);
constexpr nw::MissChanceType miss_chance_type_melee = nw::MissChanceType::make(3);
constexpr nw::MissChanceType miss_chance_type_normal = nw::MissChanceType::make(0);
constexpr nw::MissChanceType miss_chance_type_ranged = nw::MissChanceType::make(2);

constexpr nw::ModifierType mod_type_ability = nw::ModifierType::make(0);
constexpr nw::ModifierType mod_type_armor_class = nw::ModifierType::make(1);
constexpr nw::ModifierType mod_type_attack_bonus = nw::ModifierType::make(2);
constexpr nw::ModifierType mod_type_concealment = nw::ModifierType::make(3);
constexpr nw::ModifierType mod_type_crit_multiplier = nw::ModifierType::make(4);
constexpr nw::ModifierType mod_type_crit_threat = nw::ModifierType::make(5);
constexpr nw::ModifierType mod_type_dmg_immunity = nw::ModifierType::make(6);
constexpr nw::ModifierType mod_type_dmg_reduction = nw::ModifierType::make(7);
constexpr nw::ModifierType mod_type_dmg_resistance = nw::ModifierType::make(8);
constexpr nw::ModifierType mod_type_hitpoints = nw::ModifierType::make(9);
constexpr nw::ModifierType mod_type_immunity = nw::ModifierType::make(10);
constexpr nw::ModifierType mod_type_initiative = nw::ModifierType::make(11);
constexpr nw::ModifierType mod_type_movement_speed = nw::ModifierType::make(12);
constexpr nw::ModifierType mod_type_regeneration = nw::ModifierType::make(13);
constexpr nw::ModifierType mod_type_save = nw::ModifierType::make(14);
constexpr nw::ModifierType mod_type_skill = nw::ModifierType::make(15);
constexpr nw::ModifierType mod_type_spell_immunity = nw::ModifierType::make(16);
constexpr nw::ModifierType mod_type_spell_resistance = nw::ModifierType::make(17);
constexpr nw::ModifierType mod_type_damage = nw::ModifierType::make(18);
constexpr nw::ModifierType mod_type_damage_special_attack = nw::ModifierType::make(19);

constexpr nw::Save saving_throw_fort = nw::Save::make(1);
constexpr nw::Save saving_throw_reflex = nw::Save::make(2);
constexpr nw::Save saving_throw_will = nw::Save::make(3);

constexpr nw::SaveVersus saving_throw_vs_mind_spells = nw::SaveVersus::make(1);
constexpr nw::SaveVersus saving_throw_vs_poison = nw::SaveVersus::make(2);
constexpr nw::SaveVersus saving_throw_vs_disease = nw::SaveVersus::make(3);
constexpr nw::SaveVersus saving_throw_vs_fear = nw::SaveVersus::make(4);
constexpr nw::SaveVersus saving_throw_vs_sonic = nw::SaveVersus::make(5);
constexpr nw::SaveVersus saving_throw_vs_acid = nw::SaveVersus::make(6);
constexpr nw::SaveVersus saving_throw_vs_fire = nw::SaveVersus::make(7);
constexpr nw::SaveVersus saving_throw_vs_electricity = nw::SaveVersus::make(8);
constexpr nw::SaveVersus saving_throw_vs_positive = nw::SaveVersus::make(9);
constexpr nw::SaveVersus saving_throw_vs_negative = nw::SaveVersus::make(10);
constexpr nw::SaveVersus saving_throw_vs_death = nw::SaveVersus::make(11);
constexpr nw::SaveVersus saving_throw_vs_cold = nw::SaveVersus::make(12);
constexpr nw::SaveVersus saving_throw_vs_divine = nw::SaveVersus::make(13);
constexpr nw::SaveVersus saving_throw_vs_trap = nw::SaveVersus::make(14);
constexpr nw::SaveVersus saving_throw_vs_spell = nw::SaveVersus::make(15);
constexpr nw::SaveVersus saving_throw_vs_good = nw::SaveVersus::make(16);
constexpr nw::SaveVersus saving_throw_vs_evil = nw::SaveVersus::make(17);
constexpr nw::SaveVersus saving_throw_vs_law = nw::SaveVersus::make(18);
constexpr nw::SaveVersus saving_throw_vs_chaos = nw::SaveVersus::make(19);

constexpr nw::SpecialAttack special_attack_aoo = nw::SpecialAttack::make(65002);
constexpr nw::SpecialAttack special_attack_called_shot_arm = nw::SpecialAttack::make(65001);
constexpr nw::SpecialAttack special_attack_called_shot_leg = nw::SpecialAttack::make(65000);
constexpr nw::SpecialAttack special_attack_cleave = nw::SpecialAttack::make(6);
constexpr nw::SpecialAttack special_attack_cleave_great = nw::SpecialAttack::make(391);
constexpr nw::SpecialAttack special_attack_disarm = nw::SpecialAttack::make(9);
constexpr nw::SpecialAttack special_attack_disarm_improved = nw::SpecialAttack::make(16);
constexpr nw::SpecialAttack special_attack_ki_damage = nw::SpecialAttack::make(882);
constexpr nw::SpecialAttack special_attack_knockdown = nw::SpecialAttack::make(23);
constexpr nw::SpecialAttack special_attack_knockdown_improved = nw::SpecialAttack::make(17);
constexpr nw::SpecialAttack special_attack_quivering_palm = nw::SpecialAttack::make(296);
constexpr nw::SpecialAttack special_attack_sap = nw::SpecialAttack::make(31);
constexpr nw::SpecialAttack special_attack_smite_evil = nw::SpecialAttack::make(301);
constexpr nw::SpecialAttack special_attack_smite_good = nw::SpecialAttack::make(472);
constexpr nw::SpecialAttack special_attack_stunning_fist = nw::SpecialAttack::make(39);

} // namespace nwn1
